﻿namespace PinEnc
{
    class Pin
    {
        private PinEncryption pinEncryption;

        public Pin(string uid, string value, string pin)
        {
            WeakPin weakPin = new WeakPin();
            weakPin.ContainsDuplicatesMessege = "Your entered PIN contains duplicates";
            weakPin.IsLikelyBirthdateMessege = "Your entered PIN is likely a year an easy to guess.";
            weakPin.IsPatternMessege = "Your entered PIN is a pinpad pattern";
            weakPin.IsPinPadPatternMessege = "Your entered PIN is a pinpad pattern";
            weakPin.IsSequenceMessege = "Your entered PIN is a pinpad well known sequence.";
            weakPin.IsTopUsedPinMessege = "Your entered PIN is too easy to guess.";
            
            pinEncryption = new PinEncryption(new PinEncoder(pin), new PublicKey(uid, value),weakPin);
        }

        public string RsaEncodedDetailsbase64()
        {
            return pinEncryption.GetDetails();
        }

        public string EncodedMsgBase64()
        {
            return pinEncryption.GetMessege();
        }

        public string GetInfo()
        {
            return pinEncryption.GetInfo();
        }

        public bool IsWeak()
        {
            return pinEncryption.IsWeak();
        }
    }
}
